Index: trunk/kernel/kern/process.h
===================================================================
--- trunk/kernel/kern/process.h	(revision 690)
+++ trunk/kernel/kern/process.h	(revision 1)
@@ -408,216 +262,111 @@
 process_t * process_get_local_copy( pid_t pid );
 
-/*********************************************************************************************
- * This function returns the parent process identifier for a remote process descriptor
- * identified by an extended pointer.
- *********************************************************************************************
- * @ process_xp   : extended pointer on remote process descriptor.
- * @ returns parent process dentifier.
- ********************************************************************************************/
-pid_t process_get_ppid( xptr_t process_xp );
-
-/*********************************************************************************************
- * This function implements the "execve" system call, and is called by sys_exec() function.
- * It must be called by the main thread of the calling "old" process.
- * The <exec_info> structure in process descriptor contains all informations required
- * to update both the calling process descriptor and the calling thread descriptor.
- * The "new" process keep the "old" process PID and PPID, all open files, and env variables,
- * the vfs_root and vfs_cwd, but build a brand new memory image (new VMM from the .elf file).
- * It is executed in the local cluster, that becomes both the "owner" and the "reference"
- * cluster for the "new" process.
- *********************************************************************************************
- * Implementation note:
- * It executes the following sequence:
- * 1) it creates a file descriptor for the .elf file (pathname in exec_info).
- * 2) it deletes all other threads than the main thread, in all clusters.
- * 3) it reset the existing VMM (remove all user vsegs).
- * 4) it build the "args" user vseg from process exec_info, and registers in the VMM. 
- * 5) TODO it build the "envs" user vseg from process exec_info, and registers in the VMM.
- * 6) it get the "code" and "data" user vsegs from the .elf file, and registers in the VMM.
- * 7) it allocates an user "stack" vseg, and registers in the VMM
- * 8) it calls thread_user_exec() to complete thread initialisation and jumps to user code.
- *********************************************************************************************
+/********************************************************************************************* 
+ * This function builds a new reference process descriptor and associated main thread.
+ * It is executed in the local cluster, that becomes both "owner" and "reference".
+ * The new process descriptor and the main_thread are initialised using only informations 
+ * found in the local exec_info structure, that must be build by the caller.
+ * - It can be called by the process_init_create() function to build the "init" process.
+ * - It can be called directly by the sys_exec() function in case of local exec.
+ * - It can be called through the rpc_process_exec_server() function in case of remote exec.
+ ********************************************************************************************* 
+ * @ exec_info   : [in]  pointer on the exec_info structure.
  * @ return 0 if success / return non-zero if error.
  ********************************************************************************************/
-error_t process_make_exec( void );
-
-/*********************************************************************************************
- * This function implements the "fork" system call, and is called by the sys_fork() function,
- * likely through the RPC_PROCESS_MAKE_FORK. 
- * It allocates memory and initializes a new child process descriptor, and the associated
- * child thread descriptor in local cluster. It involves up to three different clusters:
- * - the child (local) cluster can be any cluster selected by the sys_fork function.
- * - the parent cluster must be the reference cluster for the parent process.
- * - the client cluster containing the thread requesting the fork can be any cluster.
- * The new child process descriptor is initialised from informations found in the parent
- * reference process descriptor, containing the complete process description.
- * The new child thread descriptor is initialised from informations found in the parent
- * thread descriptor.
- *********************************************************************************************
- * @ parent_process_xp  : extended pointer on the reference parent process.
- * @ parent_thread_xp   : extended pointer on the parent thread requesting the fork.
- * @ child_pid          : [out] child process identifier.
- * @ child_thread_ptr   : [out] local pointer on child thread in target cluster.
- * @ return 0 if success / return non-zero if error.
- ********************************************************************************************/
-error_t process_make_fork(  xptr_t             parent_process_xp,
-                            xptr_t             parent_thread_xp,
-                            pid_t            * child_pid, 
-                            struct thread_s ** child_thread_ptr );
-
-
-/********************     fd_array  operations       ****************************************/
-
-
-/*********************************************************************************************
- * This function returns a printable string for a file descriptor type.
- * These file types are defined in the <vfs.h> file.
- *********************************************************************************************
- * @ type     : [in] file type.
- ********************************************************************************************/
-char * process_fd_type_str( uint32_t type );
-
-/*********************************************************************************************
- * This function initializes all entries of the local fd_array as empty.
- *********************************************************************************************
- * @ process  : [in] pointer on the local process descriptor.
+error_t process_make_exec( exec_info_t * exec_info );
+
+
+/********************   Signal Management Operations   **************************************/ 
+
+/********************************************************************************************* 
+ * This function TODO [AG]
+ ********************************************************************************************/
+void process_signal_handler( process_t * process );
+
+
+/********************   File Management Operations   ****************************************/ 
+
+/*********************************************************************************************
+ * This function reset the file descriptor array for a given process: no open file.
+ ********************************************************************************************* 
+ * @ process  : pointer on the local process descriptor.
  ********************************************************************************************/
 void process_fd_init( process_t * process );
 
 /*********************************************************************************************
- * This function allocates a free slot in the owner cluster process fd_array identified
- * by the <process_xp> argument, register the <file_xp> argument in the allocated slot,
- * and return the slot index in the <fdid> buffer.
- * It can be called by any thread in any cluster.
- * It takes the lock protecting the fd_array against concurrent slot allocations.
- * Note: we must use the owner process descriptor, because only this fd_array contains
- * all files open by a given process.
- *********************************************************************************************
- * @ process_xp : [in]  extended pointer on owner process.
- * @ file_xp    : [in]  extended pointer on the file descriptor to be registered.
- * @ fdid       : [out] buffer for allocated fd_array slot index.
- * @ return 0 if success / return -1 if array full.
- ********************************************************************************************/
-error_t process_fd_register( xptr_t      process_xp,
-                             xptr_t      file_xp,
-                             uint32_t  * fdid );
-
-/*********************************************************************************************
- * This function uses as many remote accesses as required, to reset one fd_array[] entry,
- * identified by the <fdid> argument, in all clusters containing a copy of the 
- * process descriptor, identified by the <process_xp> argument. 
- * It can be called by any thread in any cluster.
- * It takes the lock protecting the list of copies.
- * Note: we must use the owner process descriptor, because only this owner cluster contains
- * the complete list of process copies.
- *********************************************************************************************
- * @ process_xp  : [in] extended pointer on the owner process descriptor.
- * @ fdid        : [in] file descriptor index in the fd_array.
- ********************************************************************************************/
-void process_fd_remove( xptr_t     process_xp,
-                        uint32_t   fdid );
-
-/*********************************************************************************************
- * This function scan the fd_array to close all files (or sockets) registered in the process
- * fd_array identified by the <process_xp> argument. It call the sys_close() function for 
- * each registered entry, to release all allocated memory, and reset this entry in all
- * process descriptors copies.
- * It takes the lock protecting the fd_array against concurrent accesses.
- * Note: we must use the owner process descriptor, because only this owner cluster contains
- * the complete list of process copies.
- *********************************************************************************************
- * @ process_xp  : [in] extended pointer on the owner process descriptor.
- ********************************************************************************************/
-void process_fd_clean_all( xptr_t process_xp );
-
-/*********************************************************************************************
- * This function returns an extended pointer on a file descriptor identified by its <fdid>
- * index in fd_array of the local process, identified by the <process> argument.
- * It can be called by any thread running in any cluster.
- * It accesses first the local process descriptor. In case of local miss, it takes
- * the lock protecting the reference fd_array, and access the reference process descriptor.
- * It updates the local fd_array when the file descriptor exists in owner cluster. 
- * It release the lock protecting the reference fd_array.
- *********************************************************************************************
- * @ process  : local pointer on local process descriptor.
- * @ fdid     : file descriptor index in the fd_array.
- * @ return extended pointer on file descriptor if success / return XPTR_NULL if not found.
- ********************************************************************************************/
-xptr_t process_fd_get_xptr_from_local( process_t * process,
-                                       uint32_t    fdid );
-
-/*********************************************************************************************
- * This function returns an extended pointer on a file descriptor identified by its <fdid>
- * index in the fd_array of the owner process, identified by the <process_xp> argument,
- * accessing directly the fd_array in owner cluster. It can be called by any thread running
- * in any cluster, but the local fd_array copy is not updated.
- *********************************************************************************************
- * @ process_xp  : extended pointer on the owner process descriptor.
- * @ fdid        : file descriptor index in the fd_array.
- * @ return extended pointer on file descriptor if success / return XPTR_NULL if not found.
- ********************************************************************************************/
-xptr_t process_fd_get_xptr_from_owner( xptr_t      process_xp,
-                                       uint32_t    fdid );
-
-/*********************************************************************************************
- * This function scans all entries in a fd_array, identified by the <src_xp> argument, that
- * must be the process descriptor in owner cluster. For each non-zero entry, it allocates a
- * new file descriptor in the cluster containing the involved inode, and registers it in the
- * fd_array identified by the <dst_xp> argument, that must also be the process descriptor in
- * owner cluster. The calling thread itself can be running in any cluster.
- * It takes the lock protecting the <src_xp> fd_array against concurrent accesses.
- *********************************************************************************************
- * @ dst_xp   : extended pointer on the source process descriptor (in owner cluster).
- * @ src_xp   : extended pointer on the destination process descriptor (in owner cluster).
- * @ return 0 if success / return -1 if failure
- ********************************************************************************************/
-error_t process_fd_replicate( xptr_t dst_xp,
-                              xptr_t src_xp );
-
-/*********************************************************************************************
- * This function checks the current number of open files for a given process.
- * It can be called by any thread in any cluster, because it uses portable remote access
- * primitives to access the reference process descriptor.
- * It does not take the lock protecting the reference fd_array.
- *********************************************************************************************
+ * This function closes all open files and releases all file descriptors.
+ ********************************************************************************************* 
+ * @ process  : pointer on the local process descriptor.
+ ********************************************************************************************/
+void process_fd_destroy( process_t * process );
+
+/*********************************************************************************************
+ * This function checks the number of open files for a given process. 
+ ********************************************************************************************* 
+ * @ process  : pointer on the local process descriptor.
  * @ returns true if file descriptor array full.
  ********************************************************************************************/
-bool_t process_fd_array_full( void );
-
-/*********************************************************************************************
- * This debug function diplays on the kernel terminal TXT0 detailed informations on the
- * set of file descriptors registered in the fd_array of a process descriptor identified
- * by the <process_xp> argument. 
- *********************************************************************************************
- * @ process_xp    : [in] extended pointer on process descriptor.
- ********************************************************************************************/
-void process_fd_display( xptr_t process_xp );
-
-/*********************************************************************************************
- * This utility function builds in the buffer defined by the <buffer> and <size> arguments
- * a printable string describing the current state of a process descriptor identified 
- * by the <process_xp> argument, or a WARNING message if the buffer size is too small.
- *********************************************************************************************
- * @ process_xp  : extended pointer on target process descriptor.
- * @ buffer      : kernel buffer for string.
- * @ size        : buffer size in bytes.
- * @ return always the string length (not including NUL), that can be a warning message.
- ********************************************************************************************/
-uint32_t process_build_string( xptr_t   process_xp,
-                               char   * buffer,
-                               uint32_t size );
-
-/********************   Thread Related Operations   *****************************************/
-
-/*********************************************************************************************
- * This function atomically registers a new thread identified by the <thread> argument 
- * in the th_tbl[] array of the local process descriptor identified by the <process>
- * argument. It checks that there is an available slot in the local th_tbl[] array,
- * and allocates a new LTID using the relevant lock depending on the kernel/user type,
- * and returns the global thread identifier in the <trdid> buffer.
- *********************************************************************************************
- * @ process  : [in]  pointer on the local process descriptor.
- * @ thread   : [in]  pointer on new thread to be registered.
- * @ trdid    : [out] buffer for allocated trdid.
+bool_t process_fd_array_full( process_t * process );
+
+/*********************************************************************************************
+ * These functions allocates a slot in the fd_array for a given process,
+ * and returns the file descriptor index.
+ ********************************************************************************************* 
+ * @ process  : pointer on the local process descriptor.
+ * @ file     : extended pointer on the file descriptor.
+ * @ fd       : [out] file descriptor index
+ * @ return 0 if success / return EMFILE if array full.
+ ********************************************************************************************/
+error_t process_fd_allocate( process_t * process, 
+                             xptr_t      file_xp, 
+                             uint32_t  * fd );
+
+/*********************************************************************************************
+ * This function releases an existing file descriptor from the process fd_array. 
+ ********************************************************************************************* 
+ * @ process  : pointer on the local process descriptor.
+ * @ return 0 if success / return EBADF if illegal file descriptor.
+ ********************************************************************************************/
+error_t process_fd_release( process_t * process,
+                            uint32_t    fd );
+
+/*********************************************************************************************
+ * This function copies all non-zero entries from a local <src> fd_array,
+ * embedded in a process descriptor, to another local <dst_xp> fd_array, embedded
+ * in another process descriptor. 
+ * It takes the remote lock protecting the <src> fd_array during the copy.
+ * For each involved file descriptor, the refcount is incremented. 
+ ********************************************************************************************* 
+ * @ dst   : pointer on the destination fd_array_t.
+ * @ src   : pointer on the source fd_array_t.
+ ********************************************************************************************/
+void process_fd_local_copy( fd_array_t * dst,
+                            fd_array_t * src );
+
+/*********************************************************************************************
+ * This function copies all non-zero entries from a remote <src_xp> fd_array,
+ * embedded in a process descriptor, to another remote <dst_xp> fd_array, embedded
+ * in another process descriptor. The calling thread can be running in any cluster.
+ * It takes the remote lock protecting the <src_xp> fd_array during the copy.
+ * For each involved file descriptor, the refcount is incremented. 
+ ********************************************************************************************* 
+ * @ dst_xp   : extended pointer on the destination fd_array_t.
+ * @ src_xp   : extended pointer on the source fd_array_t.
+ ********************************************************************************************/
+void process_fd_remote_copy( xptr_t dst_xp,
+                             xptr_t src_xp );
+
+
+/********************   Thread Related Operations   *****************************************/ 
+
+/*********************************************************************************************
+ * This function registers a new thread in the local process descriptor.
+ * It checks that there is an available slot in the local th_tbl[] array,
+ * allocates a new LTID, and registers the new thread in the th_tbl[].
+ * WARNING : the lock protecting the th_tbl[] must be taken by the caller.
+ ********************************************************************************************* 
+ * @ process  : pointer on the local process descriptor.
+ * @ thread   : pointer on new thread to be registered.
+ * @ trdid    : [out] address of buffer for allocated trdid.
  * @ returns 0 if success / returns non zero if no slot available.
  ********************************************************************************************/
@@ -627,108 +376,11 @@
 
 /*********************************************************************************************
- * This function atomically removes a thread identified by the <thread> argument from 
- * the local process descriptor th_tbl[] array, and returns the number of thread currently
- * registered in th_tbl[] array before this remove.
- *********************************************************************************************
- * @ thread   : pointer on thread to be removed.
- * @ returns number of threads registered in th_tbl before thread remove.
- ********************************************************************************************/
-uint32_t process_remove_thread( struct thread_s * thread );
-
-
-/***************   Terminals related operations  ********************************************/
-
-/*********************************************************************************************
- * This function scan the set of user TXT terminals to find a free terminal
- * (the list of attached processes is empty for a free TXT terminal).
- * It is called only by the process_reference_init() function when creating a KSH process.
- * It makes a kernel panic if no free TXT terminal is found.
- * The allocated TXT terminal is only released when the KSH process is deleted.
- *********************************************************************************************
- * @ return TXT terminal index if succes / kernel panic if no terminal found.
- ********************************************************************************************/
-uint32_t process_txt_alloc( void );
-
-/*********************************************************************************************
- * This function attach a process, identified by the <process_xp> argument to a TXT terminal,
- * identified by the <txt_id> channel index argument.
- * The process descriptor identified by the <process_xp> argument must be in the owner
- * cluster. It insert the process descriptor in the xlist rooted in the TXT_RX device.
- * It is called by the process_reference_init() function.
- *********************************************************************************************
- * @ process_xp : extended pointer on process descriptor in owner cluster.
- * @ txt_id     : TXT channel index.
- ********************************************************************************************/
-void process_txt_attach( xptr_t    process_xp,
-                         uint32_t  txt_id );
-
-/*********************************************************************************************
- * This function detach a process, identified by the <process_xp> argument,
- * from the list of process attached to a given TXT terminal. It transfer the TXT ownership
- * to another process, if the detached process is the TXT owner.
- * The process descriptor identified by the <process_xp> argument must be in the owner
- * cluster, but the calling thread can be running in any cluster. 
- *********************************************************************************************
- * @ process_xp  : extended pointer on process descriptor in owner cluster.
- ********************************************************************************************/
-void process_txt_detach( xptr_t  process_xp );                     
-
-/*********************************************************************************************
- * This function returns the TXT terminal index allocated to a process identified by the
- * <process_xp> argument. The process descriptor identified by the <process_xp> argument 
- * must be in the owner cluster, but the calling thread can be running in any cluster. 
- *********************************************************************************************
- * @ process_xp  : extended pointer on process descriptor in owner cluster.
- ********************************************************************************************/
-uint32_t process_txt_get_index( xptr_t process_xp );
-
-/*********************************************************************************************
- * This function gives a process identified by the <process_xp> argument the 
- * ownership of its attached TXT_RX terminal (i.e. put the process in foreground).
- * It can be called by a thread running in any cluster, but the target process descriptor
- * must be in the owner cluster.
- *********************************************************************************************
- * @ owner_xp  : extended pointer on process descriptor in owner cluster.
- ********************************************************************************************/
-void process_txt_set_ownership( xptr_t process_xp );
-
-/*********************************************************************************************
- * When the target process identified by the <owner_xp> argument has the exclusive ownership
- * of the TXT_RX terminal, this function transfer this ownership to another process attached
- * to the same terminal. The target process descriptor must be the process owner.
- * This function does nothing if the target process is not the TXT owner.
- * - If the current owner is not the KSH process, the new owner is the KSH process.
- * - If the current owner is the KSH process, the new owner is another attached process.
- * - If there is no other attached process, the TXT has no more defined owner. 
- *********************************************************************************************
- * @ process_xp  : extended pointer on process descriptor in owner cluster.
- ********************************************************************************************/
-void process_txt_transfer_ownership( xptr_t process_xp );
-
-/*********************************************************************************************
- * This function returns true if the  process identified by the <process_xp> argument
- * is the TXT owner. It can be called by a thread running in any cluster, but the
- * process_xp must be the owner cluster process descriptor. 
- *********************************************************************************************
- * @ returns true if target process is TXT owner.
- ********************************************************************************************/
-bool_t process_txt_is_owner( xptr_t process_xp );
-
-/*********************************************************************************************
- * This function returns an extended pointer on the current TXT owner process, 
- * for the TXT terminal identified by the <channel> index. 
- *********************************************************************************************
- * @ channel : TXT channel.
- * @ return extended pointer on TXT owner process.
- ********************************************************************************************/
-xptr_t process_txt_get_owner( uint32_t channel );
-
-/*********************************************************************************************
- * This debug function diplays on the kernel terminal the list of processes attached
- * to a given terminal identified by the <txt_id> argument.
- *********************************************************************************************
- * @ txt_id  : TXT terminal channel.
- ********************************************************************************************/
-void process_txt_display( uint32_t txt_id );
+ * This function removes a thread registration from the local process descriptor.
+ * WARNING : the lock protecting the th_tbl[] must be taken by the caller.
+ ********************************************************************************************* 
+ * @ thread   : local pointer on thread to be removed.
+ ********************************************************************************************/
+void process_remove_thread( struct thread_s * thread );
+
 
 
